<?php

namespace Classes\Migration;

class v20220114_310005_performance_templates extends AbstractMigration
{

    public function up()
    {
        $sql = <<<'SQL'
INSERT INTO ReviewTemplates (name, description, items, created, updated) VALUES ('Employee Self Feedback', 'This is a sample employee self-feedback. Based on your organization you can update this template or create a new template.', '[{"id":"items_1","field_label":"What accomplishments are you most proud of?","field_type":"textarea","field_validation":"","field_help":"Please mention the accomplishments relevant to the performance review period.","name":"whataccomplishmentsareyoumostproudof","data":"[\\"whataccomplishmentsareyoumostproudof\\",{\\"label\\":\\"What accomplishments are you most proud of?\\",\\"type\\":\\"textarea\\",\\"validation\\":\\"\\",\\"help\\":\\"Please mention the accomplishments relevant to the performance review period.\\"}]"},{"id":"items_2","field_label":"Which goals did you meet?","field_type":"textarea","field_validation":"","name":"whichgoalsdidyoumeet","data":"[\\"whichgoalsdidyoumeet\\",{\\"label\\":\\"Which goals did you meet?\\",\\"type\\":\\"textarea\\",\\"validation\\":\\"\\"}]"},{"id":"items_3","field_label":"Which goals fell short?","field_type":"textarea","field_validation":"","name":"whichgoalsfellshort","data":"[\\"whichgoalsfellshort\\",{\\"label\\":\\"Which goals fell short?\\",\\"type\\":\\"textarea\\",\\"validation\\":\\"\\"}]"},{"id":"items_4","field_label":"What motivates you to get your job done?","field_type":"textarea","field_validation":"","name":"whatmotivatesyoutogetyourjobdone","data":"[\\"whatmotivatesyoutogetyourjobdone\\",{\\"label\\":\\"What motivates you to get your job done?\\",\\"type\\":\\"textarea\\",\\"validation\\":\\"\\"}]"},{"id":"items_5","field_label":"What can your manager do to make your job more enjoyable?","field_type":"textarea","field_validation":"","name":"whatcanyourmanagerdotomakeyourjobmoreenjoyable","data":"[\\"whatcanyourmanagerdotomakeyourjobmoreenjoyable\\",{\\"label\\":\\"What can your manager do to make your job more enjoyable?\\",\\"type\\":\\"textarea\\",\\"validation\\":\\"\\"}]"},{"id":"items_6","field_label":"What are your ideal working conditions to be the most productive?","field_type":"textarea","field_validation":"","name":"whatareyouridealworkingconditionstobethemostproductive","data":"[\\"whatareyouridealworkingconditionstobethemostproductive\\",{\\"label\\":\\"What are your ideal working conditions to be the most productive?\\",\\"type\\":\\"textarea\\",\\"validation\\":\\"\\"}]"}]', '2020-11-15 00:20:20', '2020-11-15 00:20:20');
SQL;

        $this->executeQuery($sql);

        $sql = <<<'SQL'
INSERT INTO ReviewTemplates (name, description, items, created, updated) VALUES ('Peer feedback', 'This is a sample peer feedback. Based on your organization you can update this template or create a new template.', '[{"id":"items_1","field_label":"How collaborative is your colleague? Please provide an example.","field_type":"textarea","field_validation":"","name":"howcollaborativeisyourcolleaguepleaseprovideanexample","data":"[\\"howcollaborativeisyourcolleaguepleaseprovideanexample\\",{\\"label\\":\\"How collaborative is your colleague? Please provide an example.\\",\\"type\\":\\"textarea\\",\\"validation\\":\\"\\"}]"},{"id":"items_2","field_label":"Do you consider your colleague as a good team player?","field_type":"select2","field_validation":"","field_options":"Yes\\nMost of the time\\nSometimes\\nNo","name":"doyouconsideryourcolleagueasagoodteamplayer","data":"[\\"doyouconsideryourcolleagueasagoodteamplayer\\",{\\"label\\":\\"Do you consider your colleague as a good team player?\\",\\"type\\":\\"select2\\",\\"validation\\":\\"\\",\\"source\\":[[\\"Yes\\",\\"Yes\\"],[\\"Most of the time\\",\\"Most of the time\\"],[\\"Sometimes\\",\\"Sometimes\\"],[\\"No\\",\\"No\\"]]}]"},{"id":"items_3","field_label":"How proactive and supportive is your colleague? Please provide an example.","field_type":"textarea","field_validation":"","name":"howproactiveandsupportiveisyourcolleaguepleaseprovideanexample","data":"[\\"howproactiveandsupportiveisyourcolleaguepleaseprovideanexample\\",{\\"label\\":\\"How proactive and supportive is your colleague? Please provide an example.\\",\\"type\\":\\"textarea\\",\\"validation\\":\\"\\"}]"},{"id":"items_4","field_label":"How do you rate your colleagueâ€™s communication skills when it comes to delivering critical messages in verbal and written communication?","field_type":"textarea","field_validation":"","name":"howdoyourateyourcolleaguescommunicationskillswhenitcomestodeliveringcriticalmessagesinverbalandwrittencommunication","data":"[\\"howdoyourateyourcolleaguescommunicationskillswhenitcomestodeliveringcriticalmessagesinverbalandwrittencommunication\\",{\\"label\\":\\"How do you rate your colleagueâ€™s communication skills when it comes to delivering critical messages in verbal and written communication?\\",\\"type\\":\\"textarea\\",\\"validation\\":\\"\\"}]"},{"id":"items_5","field_label":"Does your colleague demonstrate high standards of integrity and ethics?","field_type":"textarea","field_validation":"","name":"doesyourcolleaguedemonstratehighstandardsofintegrityandethics","data":"[\\"doesyourcolleaguedemonstratehighstandardsofintegrityandethics\\",{\\"label\\":\\"Does your colleague demonstrate high standards of integrity and ethics?\\",\\"type\\":\\"textarea\\",\\"validation\\":\\"\\"}]"},{"id":"items_6","field_label":"Is your colleague a good fit for the company culture?","field_type":"textarea","field_validation":"","name":"isyourcolleagueagoodfitforthecompanyculture","data":"[\\"isyourcolleagueagoodfitforthecompanyculture\\",{\\"label\\":\\"Is your colleague a good fit for the company culture?\\",\\"type\\":\\"textarea\\",\\"validation\\":\\"\\"}]"}]', '2020-11-15 00:52:51', '2020-11-15 00:52:51');
SQL;

        return $this->executeQuery($sql);
    }

    public function down()
    {
        return true;
    }
}
